REM *************************************
REM *  		SUPER MIND		*
REM *	by J.D. Sackman		1982	*
REM *************************************
REM Modified 12-JAN-83 by Kelly Smith, Wizard of OsZ
REM Copyright (C) 1983 by Jeffry D. Sackman
%CHAIN 50,14000,1000,1000
REM *********GRAPHIC VARIABLES & FUNCTIONS********
BEL$=CHR$(7)
UP$=CHR$(11)
CLR$=CHR$(26)
HOME$=CHR$(30)
ESC$=CHR$(27)
DIM$=ESC$+CHR$(41)
BRITE$=ESC$+CHR$(40)
GR$=ESC$+CHR$(103)
GROFF$=ESC$+CHR$(71)
UL$=ESC$+CHR$(108)
ULOFF$=ESC$+CHR$(109)
INS$=ESC$+CHR$(81)
DELINE$=ESC$+CHR$(82)
DELRIGHT$=ESC$+CHR$(84)
DEL$=ESC$+CHR$(87)
REM FUNCTION TO POSITION CURSOR AT GIVEN
REM LINE AND COLUMN
DEF FN.CURSOR$(LINE%,COLUMN%)=ESC$+"="+CHR$(LINE%+32)+CHR$(COLUMN%+32)
REM **FUNCTION TO CLEAR A LINE & READY FOR PROMPT**
DEF FN.PROMPT$(L%,C%)=FN.CURSOR$(L%,C%)+DELRIGHT$+FN.CURSOR$(L%,C%)
REM **************************************
REM ****SUPRMIND ARRAYS & VARIABLES*****
DIM GUESS$(13,5)
DIM SCRATCH$(5)
DIM ANSWER$(5)
DIM PLACE%(13)
DIM CHARA%(13)
CHOICES$="ASDFGHJKL"
REM     * 123456789 *
DIM COMMENTS$(11,4)
FOR I%=1 TO 11
	FOR J%=1 TO 4
		READ COMMENTS$(I%,J%)
	NEXT J%
NEXT I%
REM *******COMMENTS DATA***********
REM *1* 1ST TURN, >=2 RIGHT
DATA "GOOD GUESS","BEGINERS LUCK!","GOOD","GOOD START!"
REM *2* 1ST TURN, <2 RIGHT
DATA "NICE TRY","THIS ISN'T EASY!","I PICKED A HARD ONE!","OH WELL..."
REM *3* LAST TURN
DATA "LAST CHANCE!","IT'S ALMOST OVER","DON'T GET NERVOUS","ONE MORE TRY"
REM *4* 4 RIGHT
DATA "YOU'VE ALMOST GOT IT!","THE LAST ONE'S TOUGH","GUESS ONE MORE TO WIN"
DATA "ONE MORE EGG TO CRACK!"
REM *5* >PREVIOUS TURN
DATA "YOU'RE IMPROVING","HMMMM...","ANOTHER LUCKY GUESS!","GOOD!"
REM *6* <= PREVIOUS TURN
DATA "YOU'RE DETERIORATING!","DON'T BE DISCOURAGED","WHAT'S THE MATTER?"
DATA "YOU'RE BLOWING IT"
REM *7* WIN, SCORE < 7
DATA "THAT'S AMAZING!","I MADE IT TOO EASY","I DON'T BELIEVE IT!"
DATA "HUH? THAT CAN'T BE!"
REM *8* WIN, 7<SCORE<12
DATA "GOOD GAME!","JUST AVERAGE","THAT WASN'T TOO HARD","WELL..."
REM *9* WIN, SCORE>11
DATA "YOU BARELY MADE IT!","I HAD YOU SWEATING","YOU ALMOST BLEW IT!"
DATA "GOOD GAME"
REM *10* LOOSE
DATA "IT'S JUST A GAME","YOU CAN DO BETTER","IT'S NOT AN EASY GAME"
DATA "CAN'T WIN-EM ALL"
REM *11* CHEAT
DATA "I KNEW IT!","CHICKEN!","I SMELLED A CHEATER!","CAN'T TAKE IT, HUH?"
REM ********
DEF FN.COMMENT$(SET%)=COMMENTS$(SET%,INT%(RND*4)+1)
REM **************************************
REM GRAPHIC CHARACTERS
REM
CA$=CHR$(1):CC$=CHR$(3):CD$=CHR$(4):CE$=CHR$(5):CF$=CHR$(6):CG$=CHR$(7)
CH$=CHR$(8):CJ$=CHR$(10):CK$=CHR$(11):CM$=CHR$(13)
CN$=CHR$(14):CR$=CHR$(18):CT$=CHR$(20):CU$=CHR$(21)
CV$=CHR$(22):CW$=CHR$(23):CX$=CHR$(24):CY$=CHR$(25):CZ$=CHR$(26)
MIDBOARD$=CV$+" * * * * * "+CV$+">    "+CK$+"     "+CK$+"     "+CD$
BOTBOARD$=CV$:FOR I%=1 TO 30:BOTBOARD$=BOTBOARD$+CV$:NEXT I%
COVER$=CN$+CN$+CN$+CN$+CN$+CN$+CN$+CN$+CN$
BCOVER$=CV$+CV$+"1"+CV$+"2"+CV$+"3"+CV$+"4"+CV$+"5"+CV$+CV$
TCLMN$=UL$+"PLACE"+CK$+"CHAR "+CK$+" LOC "+CD$+ULOFF$
DIM BOARD$(15)
DIM LOGO$(14)
BOARD$(0)="          "+CJ$+CV$+COVER$+CV$+CH$+"                      "
BOARD$(1)=" "+CG$+CX$+CX$+CX$+CX$+CF$+"   "+BCOVER$+TCLMN$+"    "
BOARD$(2)=" "+CD$+"GAME"+CA$+" 13"+MIDBOARD$+"13  "
BOARD$(3)=" "+CD$+"    "+CA$+" 12"+MIDBOARD$+"12  "
BOARD$(4)=" "+CT$+CW$+CW$+CW$+CW$+CR$+" 11"+MIDBOARD$+"11  "
BOARD$(5)=" "+CG$+CX$+CX$+CX$+CX$+CX$+CF$+"10"+MIDBOARD$+"10  "
BOARD$(6)=" "+CD$+"SCORE"+CA$+" 9"+MIDBOARD$+"9   "
BOARD$(7)=" "+CD$+"     "+CA$+" 8"+MIDBOARD$+"8   "
BOARD$(8)=" "+CT$+CW$+CW$+CW$+CW$+CW$+CR$+" 7"+MIDBOARD$+"7   "
BOARD$(9)=" "+CG$+CX$+CX$+CX$+CX$+CF$+"  6"+MIDBOARD$+"6   "
BOARD$(10)=" "+CD$+"TURN"+CA$+"  5"+MIDBOARD$+"5   "
BOARD$(11)=" "+CD$+"    "+CA$+"  4"+MIDBOARD$+"4   "
BOARD$(12)=" "+CT$+CW$+CW$+CW$+CW$+CR$+"  3"+MIDBOARD$+"3   "
BOARD$(13)="         2"+MIDBOARD$+"2   "
BOARD$(14)="         1"+MIDBOARD$+"1   "
BOARD$(15)="          "+BOTBOARD$
LOGO$(0)=CJ$+CW$+CW$+CW$
LOGO$(1)=CW$+CW$+CW$+CH$
LOGO$(2)=CX$+CX$+CX$+CY$
LOGO$(3)="UPER"
LOGO$(4)=CV$+CH$+CJ$+CV$
LOGO$(5)=CV$+CU$+CY$+CV$
LOGO$(6)=""
LOGO$(7)=CW$+CV$+CV$+CW$
LOGO$(8)=CX$+CV$+CV$+CX$
LOGO$(9)=""
LOGO$(10)=CV$+CZ$+" "+CV$
LOGO$(11)=CV$+CT$+CZ$+CV$
LOGO$(12)=""
LOGO$(13)=CV$+CW$+CE$+CH$
LOGO$(14)=CV$+CX$+CC$+CY$
FOR I%=0 TO 14
	BOARD$(I%)=GR$+BOARD$(I%)+DIM$+LOGO$(I%)+BRITE$+GROFF$
NEXT I%
BOARD$(15)=GR$+BOARD$(15)+GROFF$
REM
REM *****************
REM *   BEGIN       *
REM *****************
PRINT CLR$:PRINT:PRINT "                     Super Mind"
PRINT "      Copyright (C) 1983 by Jeffry D. Sackman"
50 PRINT CLR$;"                   ** SUPER MIND **"
60 PRINT FN.PROMPT$(10,5);"DO YOU NEED INSTRUCTIONS (Y/N)?";
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN PRINT BEL$:GOTO 60
IF YN$="N" THEN 100
REM *******************
REM *  INSTRUCTIONS   *
REM *******************
PRINT CLR$;
PRINT "OVERVIEW"
PRINT 
PRINT "     Supermind  is  a  guessing game that  pits  you" 
PRINT "against your computer.   The computer will choose  5" 
PRINT "letters,  in a random order, and sometimes repeating" 
PRINT "letters,  and  hide  them.   You have 13 chances  to" 
PRINT "guess  not  only which letters they  are,  but  what" 
PRINT "order  they  are in.   Your score is the  number  of" 
PRINT "guesses  you made to get the right answer.   If  the" 
PRINT "game  gets too hard, there are two ways to 'cheat'," 
PRINT "if  you are willing to pay the price.   The computer" 
PRINT "gives you feedback for each guess,  as well as a few" 
PRINT "snide remarks.   You can stop a game in the  middle," 
PRINT "save it, and continue it another time."
PRINT
IF CONSTAT% THEN DUM%=CONCHAR%
PRINT "PRESS <RETURN> TO CONTINUE";
DUM%=CONCHAR%
PRINT CLR$;"PLAYING THE GAME"
PRINT
PRINT "     After  the  computer asks you  your  name,  the" 
PRINT "playing  board  will appear on the screen,  and  the" 
PRINT "game  begins.   The computer has already chosen  its" 
PRINT "letters.   They  may be any combination of 5 of  the" 
PRINT "following:"
PRINT "                     ASDFGHJKL"
PRINT "You may notice that these are all the letters in the" 
PRINT "second from the bottom row of your  keyboard.   Keep" 
PRINT "in  mind  that the combination may have one or  more" 
PRINT "repeated letters, such as ASSJK or HLKHL."
PRINT "     On the left side of the screen the GAME #, your" 
PRINT "SCORE,  and your TURN are displayed.   On the  right" 
PRINT "side are 3 columns,  PLACE,  CHAR, and LOC.  This is" 
PRINT "where  the computer tells you how much of your guess" 
PRINT "is  correct.   In  the middle of the screen  is  the" 
PRINT "playing  board  itself.   The '*'s  are  the  spaces" 
PRINT "reserved for your guesses."
PRINT
IF CONSTAT% THEN DUM%=CONCHAR%
PRINT "PRESS <RETURN> TO CONTINUE";
DUM%=CONCHAR%
PRINT CLR$;"BOARD LAYOUT"
PRINT "     The  computer  displays messages to you at  the" 
PRINT "TOP  of the screen.   It lists your options  at  the" 
PRINT "BOTTOM of the screen.  Your response follows the '>'" 
PRINT "which is above the options.   Be sure to always look" 
PRINT "at  the  message  on top,  then the options  at  the" 
PRINT "bottom of the screen before responding."
PRINT "     Your  guesses begin at the bottom of the  board" 
PRINT "and are displayed one on top of the other so you can" 
PRINT "compare  them.   The  feedback  for  each  guess  is" 
PRINT "displayed  alongside it.   The guesses are  numbered" 
PRINT "from the bottom up, 1 to 13."
PRINT "     There are 5 spaces to each guess, just as there" 
PRINT "are 5 characters in the combination the computer has" 
PRINT "chosen.  These spaces are also numbered, 1 to 5."
PRINT "e.g.:     1 2 3 4 5"
PRINT "          F G J S F"
PRINT
IF CONSTAT% THEN DUM%=CONCHAR%
PRINT "PRESS <RETURN> TO CONTINUE";
DUM%=CONCHAR%
PRINT CLR$;"ENTERING A GUESS"
PRINT "     To  enter a guess,  press 'E' for 'Enter'  when" 
PRINT "the computer asks you what you want to do and offers" 
PRINT "'Enter' as an option.  You will then be asked  which" 
PRINT "space,  1 to 5, you want to guess.  When you respond" 
PRINT "with  a number from 1 to 5,  you will be asked which" 
PRINT "character you guess for that space.   You must  fill" 
PRINT "up all 5 spaces before you are done with your guess." 
PRINT "You  may fill the spaces in any order you wish,  and" 
PRINT "change  any  or all of them.   It's a good  idea  to" 
PRINT "enter the ones you are sure about first."
PRINT "     When  you  have  filled all 5  spaces  and  are" 
PRINT "satisfied with them,  press <RETURN> to show you are" 
PRINT "done.   The  computer will ask you if that  is  your" 
PRINT "guess.  Answer Y for yes or N for no.  If you answer" 
PRINT "no, then you have a chance to change your guess.  If" 
PRINT "you  answer yes,  the computer will proceed to check" 
PRINT "your guess against the answer."
PRINT
IF CONSTAT% THEN DUM%=CONCHAR%
PRINT "PRESS <RETURN> TO CONTINUE";
DUM%=CONCHAR%
PRINT CLR$;"FEEDBACK"
PRINT "     You  are  given two types of feedback  to  each" 
PRINT "guess.   Under the column PLACE,  the computer  will" 
PRINT "tell  you how many of the characters you guessed are" 
PRINT "in  the same space as the characters in the  answer."  
PRINT "For example, if your guess was KJFGH, and the answer" 
PRINT "was  JDFAH,  the number in the place column will  be" 
PRINT "two.  The computer will not tell you which ones were" 
PRINT "correct  (F  in  space 3 and H in  space  5  in  the"
PRINT "example), only how many."
PRINT "     Under  the column CHAR,  the computer will tell" 
PRINT "you  haw  many of the characters in your  guess  are" 
PRINT "also  characters in the answer,  not counting  those" 
PRINT "you guessed in the right PLACE.   Thus, in the above" 
PRINT "example,  the number in the CHARA column would be 1," 
PRINT "for  the  J  you guessed  in space  2,  which  was "
PRINT "actually  in space 1.   The characters you  guessed" 
PRINT "correctly,  F  and H,  are not counted in the  CHARA" 
PRINT "column.   Again,  you  are not told which ones  were" 
PRINT "right,  only how many."
PRINT
IF CONSTAT% THEN DUM%=CONCHAR%
PRINT "PRESS <RETURN> TO CONTINUE";
DUM%=CONCHAR%
PRINT CLR$;"SCORING"
PRINT "     Each  of your guesses and the feedback for each"
PRINT "guess  is  left on the screen until the end  of  the" 
PRINT "game.   It  is  with this information that  you  can" 
PRINT "figure out the answer.  You have 13 guesses.  If you" 
PRINT "correctly guess the answer,  you win.   If your 13th" 
PRINT "guess  is wrong,  you lose.   Your score equals  the" 
PRINT "number  of  guesses it took you to  get  the  answer" 
PRINT "(unless you cheat) so that the lower your score, the" 
PRINT "better  you are doing.   You can play one game after" 
PRINT "another  and your total score for all games will  be" 
PRINT "displayed after each one is over.  During each game," 
PRINT "however,  only the score for that game is displayed."  
PRINT "When you lose a game,  your score will be 16 (if you"
PRINT "didn't cheat)."
PRINT
IF CONSTAT% THEN DUM%=CONCHAR%
PRINT "PRESS <RETURN> TO CONTINUE";
DUM%=CONCHAR%
PRINT CLR$;"CHEATING"
PRINT "     If you get fustrated,  there are also two  ways "
PRINT "to  cheat.   Enter 'C' for Cheat when that is one of "
PRINT "the  options.   You can then either  Repent  (change "
PRINT "your mind about cheating),  Peek,  or Show.   If you "
PRINT "Peek, you can choose one space of the answer to peek" 
PRINT "at.   It  will be displayed at the top of the board."  
PRINT "If  you Show,  you can choose one of  your  guesses."  
PRINT "Under the LOC column,  you will see which spaces you"
PRINT "guessed  correctly.   '145'  means your guesses  for" 
PRINT "spaces 1, 4 and 5 of that guess were correct."
PRINT "     Whether you Peek or Show,  you will only have a "
PRINT "few  seconds to look,  so pay attention.   You  must "
PRINT "also pay a price for cheating.   The price is one to "
PRINT "nine points added to your score."
PRINT
IF CONSTAT% THEN DUM%=CONCHAR%
PRINT "PRESS <RETURN> TO CONTINUE";
DUM%=CONCHAR%
PRINT CLR$;"SAVING GAMES"
PRINT "     If you quit a game in the middle,  the computer "
PRINT "will ask you if you want to save it for  later.   Up "
PRINT "to  15 games may be saved.   Your game is filed away "
PRINT "according to your name.  The next time you play, the "
PRINT "computer will find your old game and ask you if  you "
PRINT "want  to  continue it.   If you don't,  it  will  be "
PRINT "erased."
PRINT "     Since  your old games are filed by the name you "
PRINT "enter,  be  carefull how you spell it when  you  are "
PRINT "asked  your  name.   The  computer  will  treat  two "
PRINT "spellings of the same name as two names.   Also,  if "
PRINT "there  are two 'Johns' in your family,  they  should "
PRINT "use   a  middle  initial  or  some  other  sign   to "
PRINT "distinguish them."
PRINT
IF CONSTAT% THEN DUM%=CONCHAR%
PRINT "PRESS <RETURN> TO BEGIN GAME";
DUM%=CONCHAR%
REM *********************************************************
REM *******************
REM * SET VARIABLES   *
REM *******************
100 GAME%=1:SCORE%=0:TOTALSCORE%=0:TURN%=1
PRINT CLR$;"                     ** SUPER MIND **"
FOR I%=1 TO 13
	PLACE%(I%)=0:CHARA%(I%)=0
	FOR J%=1 TO 5
		GUESS$(I%,J%)=""
	NEXT J%
NEXT I%
FOR I%=0 TO 5:SCRATCH$(I%)="":NEXT I%
PRINT FN.PROMPT$(10,1);"WHAT'S YOUR NAME";
110 INPUT LINE NAME$
RANDOMIZE
NAME$=UCASE$(NAME$)
IF LEN(NAME$)>15 THEN \
PRINT "I CAN'T REMEMBER THAT, HOW ABOUT A NICKNAME";:GOTO 110
REM ********************************
REM * CHECK FILE FOR PREVIOUS GAME *
REM ********************************
200 IF SIZE("SMIND.DAT")=0 THEN 500
IF END #1 THEN 210
OPEN "SMIND.DAT" RECL 110 AS 1
R%=1
WHILE R%<16
	READ #1,R%;FILENAME$
	IF FILENAME$=NAME$ THEN 300
	R%=R%+1
WEND
REM **NO PREVIOUS GAME FOUND
210	CLOSE 1
	R%=0
	GOTO 500
REM *********************************
REM * ASK IF CONTINUE PREVIOUS GAME *
REM *********************************
300  PRINT CLR$
PRINT FN.CURSOR$(9,1);"YOU DIDN'T FINISH YOUR LAST GAME ";NAME$
310 PRINT FN.PROMPT$(10,1);"DO YOU WANT TO CONTINUE IT NOW (Y/N)?";
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN PRINT BEL$:GOTO 310
IF YN$="Y" THEN 400
PRINT #1,R%;"$$$"
GOTO 210
REM *****************************
REM * READ VARIABLES FROM FILE  *
REM *****************************
400 PRINT
PRINT "***I'M READING YOUR LAST GAME****"
READ #1,R%;NAME$,GAME%,SCORE%,TURN%,TOTALSCORE%,ANSWERSTRING$,GUESSFILE$
FOR I%=0 TO TURN%-2
        FOR J%=1 TO 5
		GUESS$(I%+1,J%)=MID$(GUESSFILE$,(I%*5+J%),1)
	NEXT J%
NEXT I%
FOR I%=1 TO 5
	ANSWER$(I%)=MID$(ANSWERSTRING$,I%,1)
NEXT I%
REM ****SET UP PLACE AND CHARA ARRAYS****
FOR I%=1 TO TURN%-1
  FOR J%=1 TO 5
	CHKNG$=GUESS$(I%,J%)
	IF CHKNG$=ANSWER$(J%) THEN PLACE%(I%)=PLACE%(I%)+1
	IF MATCH(CHKNG$,ANSWERSTRING$,1)>0 THEN CHARA%(I%)=CHARA%(I%)+1
  NEXT J%
  CHARA%(I%)=CHARA%(I%)-PLACE%(I%)
NEXT I%
REM ******MARK RECORD AS BLANK NOW******
PRINT #1,R%;"$$$"
CLOSE 1
GOTO 900
REM ********ARRANGE ANSWER IF IT HASN'T BEEN READ FROM FILE***
500  FOR I%=1 TO 5
	ANSWER$(I%)=MID$(CHOICES$,INT%(RND*9)+1,1)
NEXT I%
ANSWERSTRING$=ANSWER$(1)+ANSWER$(2)+ANSWER$(3)+ANSWER$(4)+ANSWER$(5)
REM ********************
REM * BEGIN NEW GAME   *
REM ********************
900	GOSUB 10000
	PROMPT$="WHAT DO YOU WANT TO DO?"
REM 
REM ****************
REM * GAME CYCLE   *
REM ****************
1000 WHILE TURN%<14
GOSUB 11000
IF CONSTAT% THEN DUM%=CONCHAR%
1010 PRINT FN.PROMPT$(2,1);PROMPT$
OPTIONS$="E=enter a guess  R=redisplay  C=cheat  Q=quit"
PRINT FN.PROMPT$(21,1);OPTIONS$
1020  PRINT FN.PROMPT$(19,1);">";BEL$;
REPLY$=UCASE$(CHR$(CONCHAR%))
IF MATCH(REPLY$,"ERCQ",1)=0 THEN 1020
IF REPLY$="R" THEN GOSUB 10000:GOSUB 11000:GOTO 1010
IF REPLY$="C" THEN GOSUB 12000:GOTO 1010
IF REPLY$="Q" THEN GOTO 9000
REM ***ENTER A GUESS***
IF CONSTAT% THEN DUM%=CONCHAR%
PROMPT$="WHICH SPACE (1-5) DO YOU WANT TO GUESS?"
OPTIONS$="1 2 3 4 5 =space no.s  R=redisplay  <RETURN>=done"
1025  PRINT FN.PROMPT$(2,1);PROMPT$
PRINT FN.PROMPT$(21,1);OPTIONS$
1030 PRINT FN.PROMPT$(19,1);">";BEL$;
REPLY%=CONCHAR%
IF REPLY%=13 THEN 1040
REPLY$=UCASE$(CHR$(REPLY%))
IF MATCH(REPLY$,"12345R",1)=0 THEN PRINT BEL$:GOTO 1030
IF REPLY$="R" THEN GOSUB 10000:GOSUB 11000:GOTO 1025
SPACE%=INT%(VAL(REPLY$))
PRINT FN.PROMPT$(2,1);"WHAT IS YOUR GUESS FOR SPACE ";SPACE%
PRINT FN.PROMPT$(21,1);"A S D F G H J K L"
1035 PRINT FN.PROMPT$(19,1);">";BEL$;
REPLY$=UCASE$(CHR$(CONCHAR%))
IF MATCH(REPLY$,CHOICES$,1)=0 THEN PRINT BEL$:GOTO 1035
SCRATCH$(SPACE%)=REPLY$
PRINT FN.CURSOR$(18-TURN%,11+(SPACE%*2));SCRATCH$(SPACE%)
GOTO 1025
1040   NDONE%=0
FOR I% = 1 TO 5
	IF MATCH(SCRATCH$(I%),CHOICES$,1)=0 THEN NDONE%=-1
NEXT I%
IF CONSTAT% THEN DUM%=CONCHAR%
IF NDONE% THEN PROMPT$="FILL ALL 5 SPACES BEFORE PRESSING <RETURN>":GOTO 1025
SCRATCH$(0)=SCRATCH$(1)+SCRATCH$(2)+SCRATCH$(3)+SCRATCH$(4)+SCRATCH$(5)
PRINT FN.PROMPT$(2,1);"YOUR GUESS IS ";SCRATCH$(0);" CORRECT?"
PRINT FN.PROMPT$(21,1);"Y=yes N=no"
1045 PRINT FN.PROMPT$(19,1);">";BEL$;
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN PRINT BEL$:GOTO 1045
IF YN$="N" THEN 1025
REM ****************
REM  CHECK GUESS
REM *****************
FOR I%=1 TO 5
	GUESS$(TURN%,I%)=SCRATCH$(I%)
	CHKNG$=GUESS$(TURN%,I%)
	SCRATCH$(I%)=""
	IF CHKNG$=ANSWER$(I%) THEN PLACE%(TURN%)=PLACE%(TURN%)+1
        IF MATCH(CHKNG$,ANSWERSTRING$,1)>0 THEN CHARA%(TURN%)=CHARA%(TURN%)+1
NEXT I%
IF PLACE%(TURN%)>0 THEN CHARA%(TURN%)=CHARA%(TURN%)-PLACE%(TURN%)
SCORE%=SCORE%+1
IF PLACE%(TURN%)=5 THEN 7000
REM *********CHOOSE COMMENT**********
IF TURN%=1 AND PLACE%(TURN%)>=2 THEN SET%=1
IF TURN%=1 AND PLACE%(TURN%)<2 THEN SET%=2
IF TURN%=1 THEN GOTO 1500
IF PLACE%(TURN%)>PLACE%(TURN%-1) THEN SET%=5
IF PLACE%(TURN%)<=PLACE%(TURN%-1) THEN SET%=6
IF (PLACE%(TURN%)=PLACE%(TURN%-1)) AND (CHARA%(TURN%)>CHARA%(TURN%-1))\
	THEN SET%=5
IF PLACE%(TURN%)=4 THEN SET%=4
IF TURN%=12 THEN SET%=3
REM **********SET PROMPT************
1500	PROMPT$=FN.COMMENT$(SET%)+"   WHAT NOW?"
TURN%=TURN%+1
2000 WEND
REM **********************
REM *  LOSE ROUTINE      *
REM **********************
6000  GOSUB 10000
SCORE%=SCORE%+2
	GOSUB 11000
PROMPT$="YOU LOST "+NAME$+"- "+FN.COMMENT$(10)+"  TRY AGAIN?"
GOTO 8000
REM ****************
REM * WIN ROUTINE  *
REM ****************
7000 	GOSUB 10000
	TURN%=TURN%+1
	GOSUB 11000
IF SCORE%<7 THEN SET%=7
IF SCORE%<12 AND SCORE%>=7 THEN SET%=8
IF SCORE%>11 THEN SET%=9
PROMPT$="YOU WON "+NAME$+"! "+FN.COMMENT$(SET%)+"  PLAY AGAIN?"
REM ********************
REM * RESET VARIABLES  *
REM ********************
8000 TOTALSCORE%=SCORE%+TOTALSCORE%
SCORE%=0:TURN%=1:SCRATCH$(0)=""
FOR I%=1 TO 5
	SCRATCH$(I%)=""
	PRINT FN.CURSOR$(3,11+(I%*2));ANSWER$(I%)
NEXT I%
FOR I%=1 TO 13
	PLACE%(I%)=0
	CHARA%(I%)=0
	FOR J%=1 TO 5
		GUESS$(I%,J%)=""
	NEXT J%
NEXT I%
FOR I%=1 TO 5
	ANSWER$(I%)=MID$(CHOICES$,INT%(RND*9)+1,1)
NEXT I%
ANSWERSTRING$=ANSWER$(1)+ANSWER$(2)+ANSWER$(3)+ANSWER$(4)+ANSWER$(5)
GAME%=GAME%+1
REM ********PLAY AGAIN?*************
IF CONSTAT% THEN DUM%=CONCHAR%
PRINT FN.PROMPT$(2,1);PROMPT$
PRINT FN.PROMPT$(21,1);"Y=yes  N=no"
PRINT FN.CURSOR$(20,11);"YOUR TOTAL SCORE IS";TOTALSCORE%
8010  PRINT FN.PROMPT$(19,1);">";BEL$;
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN PRINT BEL$:GOTO 8010
IF YN$="N" THEN 9000
PROMPT$="ANOTHER GAME... WHAT DO YOU WANT TO DO NOW?"
GOSUB 10000
GOTO 1000
REM ***********************
REM * CHECK IF LEAVING    *
REM ***********************
9000 PRINT FN.PROMPT$(2,1);"YOU WANT TO QUIT ALREADY ";NAME$;"?"
PRINT FN.PROMPT$(21,1);"Y=yes  N=no"
PRINT FN.PROMPT$(19,1);">";BEL$;
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN PRINT BEL$:GOTO 9000
PROMPT$="SO... WHAT DO YOU WANT TO DO NOW?"
IF YN$="N" THEN 1000
IF SCORE%=0 THEN 20000
REM ***********************
REM * SAVE A GAME ON FILE *
REM ***********************
9100 IF SIZE("SMIND.DAT")=0 THEN 20000
9101 PRINT FN.PROMPT$(2,1);"DO YOU WANT TO SAVE THIS GAME?"
PRINT FN.PROMPT$(21,1);"Y=yes, save it  N=no don't save it"
PRINT FN.PROMPT$(19,1);">";BEL$;
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN 9101
IF YN$="N" THEN 20000
	IF END #1 THEN 9400
	OPEN "SMIND.DAT" RECL 110 AS 1
	R%=1
	WHILE R%<16
		READ #1,R%;FILENAME$
		IF FILENAME$="$$$" THEN 9200
		R%=R%+1
	WEND
	R%=1
9200	GUESSFILE$=""
	FOR I%=1 TO TURN%-1
	  FOR J%=1 TO 5
		GUESSFILE$=GUESSFILE$+GUESS$(I%,J%)
	NEXT J%:NEXT I%
PRINT #1,R%;NAME$,GAME%,SCORE%,TURN%,TOTALSCORE%,ANSWERSTRING$,GUESSFILE$
9300	CLOSE 1
	GOTO 20000
9400	PRINT FN.PROMPT$(2,1);"FILE ERROR IN";R%
	GOTO 9300
REM *********************************
REM  SUBROUTINE TO PRINT GAME BOARD *
REM *********************************
10000	PRINT CLR$
	FOR I%=0 TO 15
		PRINT FN.CURSOR$(I%+3,1);BOARD$(I%)
	NEXT I%
	PRINT HOME$
	RETURN
REM ***********************************************
REM SUBROUTINE TO INSERT VARIABLES INTO BOARD
REM ***********************************************
11000	PRINT FN.CURSOR$(6,3);GAME%
	PRINT FN.CURSOR$(10,3);SCORE%
	PRINT FN.CURSOR$(14,3);TURN%
	IF TURN%<2 THEN 11100
	FOR I%=1 TO TURN%-1
		FOR J%=1 TO 5
			PRINT FN.CURSOR$(18-I%,11+(J%*2));GUESS$(I%,J%)
		NEXT J%
		PRINT FN.CURSOR$(18-I%,26);PLACE%(I%)
		PRINT FN.CURSOR$(18-I%,31);CHARA%(I%)
	NEXT I%
11100   IF TURN%=14 THEN PRINT HOME$:RETURN
	FOR I%=1 TO 5
		IF SCRATCH$(I%)="" THEN 11110
		PRINT FN.CURSOR$(18-TURN%,11+I%*2);SCRATCH$(I%)
11110	NEXT I%
	PRINT HOME$
	RETURN
REM **********************************************
REM *  CHEATING SUBROUTINE
REM *************************
12000	GOSUB 10000
	GOSUB 11000
IF CONSTAT% THEN DUM%=CONCHAR%
PRINT FN.PROMPT$(2,1);FN.COMMENT$(11);"  WANNA PEEK, SHOW, OR REPENT?"
PRINT FN.PROMPT$(21,1);"P=peek S=show R=repent (before its too late)"
12010  PRINT FN.PROMPT$(19,1);">";BEL$;
REPLY$=UCASE$(CHR$(CONCHAR%))
IF MATCH(REPLY$,"PSR",1)=0 THEN 12010
IF REPLY$="R" THEN RETURN
IF REPLY$="S" THEN 12200
REM *****PEEK*******
12100 PRINT FN.PROMPT$(2,1);"WHICH SPACE DO YOU WANT TO PEEK AT?"
PRINT FN.PROMPT$(21,1);"1 2 3 4 5"
12110 PRINT FN.PROMPT$(19,1);">";BEL$;
REPLY$=CHR$(CONCHAR%)
IF MATCH(REPLY$,"12345",1)=0 THEN 12110
PEEK%=INT%(VAL(REPLY$))
PRINT FN.CURSOR$(3,11+(PEEK%*2));ANSWER$(PEEK%)
GOTO 12300
REM *****SHOW******
12200  IF TURN%=1 THEN 12000
PRINT FN.PROMPT$(2,1);"WHICH GUESS DO YOU WANT TO SHOW?"
PRINT FN.PROMPT$(21,1);"1 2 3 4 5 6 7 8 9 10 11 12 (less than current turn)"
12210 PRINT FN.PROMPT$(19,1);BEL$;
INPUT ">"; LINE REPLY$
IF LEN(REPLY$)>2 THEN 12210
FOR I%=1 TO LEN(REPLY$)
	IF MATCH(MID$(REPLY$,I%,1),"0123456789",1)=0 THEN 12210
NEXT I%
I%=0
SHOW%=INT%(VAL(REPLY$))
IF SHOW%>12 OR SHOW%<1 THEN 12210
IF SHOW%>=TURN% THEN 12210
SHOW$=""
FOR I%=1 TO 5
	IF GUESS$(SHOW%,I%)=ANSWER$(I%) THEN SHOW$=SHOW$+STR$(FLOAT(I%))
NEXT I%
PRINT FN.CURSOR$(18-SHOW%,36);SHOW$
REM ********SHOW CHEAT AND CHARGE THE PRICE********
12300 PRICE%=INT%(RND*10)+1
SCORE%=SCORE%+PRICE%
PRINT FN.PROMPT$(2,1);"THIS WILL COST YOU";PRICE%
FOR I%=1 TO 5000:NEXT I%
GOSUB 10000
GOSUB 11000
RETURN
REM ***************************************
20000	STOP
END
