REM *************************************
REM *              WRITEQZ		*
REM *         WRITES QUIZES FOR 	*
REM *     GHOST IN THE CHIMNEY GAME	*
REM *    by J.D. Sackman        1982	*
REM *************************************
REM Modified 12-JAN-83 by Kelly Smith, Wizard of OsZ
REM Copyright (C) 1983 by Jeffry D. Sackman
%CHAIN 50,14000,1000,1000
REM *********GRAPHIC VARIABLES & FUNCTIONS********
BEL$=CHR$(7)
BACKSP$=CHR$(8)
DOWN$=CHR$(10)
UP$=CHR$(11)
FRWRDSP$=CHR$(12)
BLINE$=CHR$(13)
CLR$=CHR$(26)
HOME$=CHR$(30)
ESC$=CHR$(27)
DIM$=ESC$+CHR$(41)
BRITE$=ESC$+CHR$(40)
INSLINE$=ESC$+CHR$(69)
GR$=ESC$+CHR$(103)
GROFF$=ESC$+CHR$(71)
UL$=ESC$+CHR$(108)
ULOFF$=ESC$+CHR$(109)
INS$=ESC$+CHR$(81)
DELINE$=ESC$+CHR$(82)
DELRIGHT$=ESC$+CHR$(84)
DEL$=ESC$+CHR$(87)
REM FUNCTION TO POSITION CURSOR AT GIVEN
REM LINE AND COLUMN
DEF FN.CURSOR$(LINE%,COLUMN%)=ESC$+"="+CHR$(LINE%+32)+CHR$(COLUMN%+32)
REM FUNCTION TO POSITION SCREEN AT GIVEN
REM LINE AND COLUMN
DEF FN.SCREEN$(LINE%,COLUMN%)=ESC$+"S"+CHR$(LINE%+32)+CHR$(COLUMN%+32)
REM FUNCTION TO CLEAR LINE OF SCREEN AND READY FOR PROMPT
DEF FN.PROMPT$(L%,C%)=FN.CURSOR$(L%,C%)+DELRIGHT$+FN.CURSOR$(L%,C%)
REM ***************************************
VALIDCHAR$="ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-"
REM ***************************************
REM ***MAIN MENU***
REM
PRINT CLR$:PRINT:PRINT "      Ghost in the Chimney Quiz Writer/Editor"
PRINT "      Copyright (C) 1983 by Jeffry D. Sackman"
FOR I=1 TO 1000:NEXT I
50 IF END #1 THEN 1000
PRINT CLR$
PRINT FN.CURSOR$(8,1);
PRINT "               WRITE OR EDIT A QUIZ FOR"
PRINT "           THE 'GHOST IN THE CHIMNEY' GAME"
PRINT
PRINT "			    -MENU-"
PRINT
PRINT TAB(5);"1 - Write a New quiz"
PRINT TAB(5);"2 - Add more questions to an existing quiz"
PRINT TAB(5);"3 - Edit an existing quiz"
PRINT TAB(5);"4 - Print out a quiz"
PRINT TAB(5);"5 - Exit back to the Ghost Menu"
60	PRINT FN.CURSOR$(19,1);"YOUR CHOICE IS NUMBER:";
70	A$=CHR$(CONCHAR%)
	IF MATCH(A$,"12345",1)>0 THEN 80
	PRINT FN.CURSOR$(19,1);DELRIGHT$
	PRINT FN.CURSOR$(19,1);"TYPE A NUMBER FROM 1 TO 5";
	GOTO 70
80	PRINT FN.CURSOR$(19,1);DELRIGHT$
	PRINT FN.CURSOR$(20,1);"YOU CHOSE NUMBER ";A$;", CORRECT?(Y/N)";
	YN$=UCASE$(CHR$(CONCHAR%))
	IF YN$="Y" THEN 90
	PRINT FN.CURSOR$(20,1);DELRIGHT$: GOTO 60
90	A%=INT%(VAL(A$))
	ON A% GOTO 100,200,300,400,490
REM *********************************************
REM *	CREATE A NEW QUIZ			*
REM *********************************************
100	PRINT CLR$;"	CREATE A NEW QUIZ"
INITIALIZE
IF CONSTAT% THEN DUM%=CONCHAR%
PRINT FN.CURSOR$(10,1);"ON WHICH DRIVE DO YOU WISH TO STORE THE QUIZ"
110	PRINT FN.PROMPT$(11,1);"A OR B?";
DRIVE$=UCASE$(CHR$(CONCHAR%))
IF MATCH(DRIVE$,"AB",1)=0 THEN PRINT BEL$:GOTO 110
PRINT FN.PROMPT$(10,1);"YOUR DISK SHOULD BE IN DRIVE ";DRIVE$
PRINT FN.PROMPT$(11,1);"PRESS <RETURN> WHEN READY OR 'N' TO CHANGE MIND";
IF UCASE$(CHR$(CONCHAR%))="N" THEN PRINT FN.PROMPT$(12,1):GOTO 110
DRIVE$=DRIVE$+":"
FILENAME$=DRIVE$+"*.*"
120 PRINT FN.PROMPT$(13,1);"NAME OF QUIZ (8 letter max)";
INPUT LINE QUIZ$
IF LEN(QUIZ$)>8 THEN PRINT FN.PROMPT$(14,1);"TOO LONG";BEL$:GOTO 120
QUIZ$=UCASE$(QUIZ$)
INVALIDCHAR%=0
FOR I%=1 TO LEN(QUIZ$)
	IF MATCH(MID$(QUIZ$,I%,1),VALIDCHAR$,1)=0 THEN INVALIDCHAR%=-1
NEXT I%
IF INVALIDCHAR% THEN\
  PRINT FN.PROMPT$(14,1);"INVALID CHARACTER";BEL$:GOTO 120
FILENAME$=DRIVE$+QUIZ$+".*"
IF SIZE(FILENAME$)>0 THEN\
  PRINT FN.PROMPT$(14,1);"FILE ALREADY EXISTS";BEL$:GOTO 120
REM ***FILENAME CHECKS OUT OK***
FILENAME$=DRIVE$+QUIZ$+".QZ"
	CREATE FILENAME$ RECL 22 AS 1
STARTAT%=2
GOTO 500	REM  WRITE ROUTINE
REM ******************************************
REM *   ADD TO AN EXISTING FILE		     *
REM ******************************************
200 PRINT CLR$;"        ADD TO AN EXISTING QUIZ"
205 INITIALIZE
210  PRINT FN.PROMPT$(9,1);"ON WHICH DRIVE IS THE QUIZ,"
PRINT FN.PROMPT$(10,1);"A OR B (OR X TO EXIT)?";
DRIVE$=UCASE$(CHR$(CONCHAR%))
IF MATCH(DRIVE$,"ABX",1)=0 THEN PRINT BEL$:GOTO 210
IF DRIVE$="X" THEN 50
DRIVE$=DRIVE$+":"
220  PRINT FN.PROMPT$(12,1);
INPUT "NAME OF QUIZ:"; LINE QUIZ$
IF LEN(QUIZ$)>8 THEN PRINT FN.PROMPT$(13,1);"TOO LONG":GOTO 220
QUIZ$=UCASE$(QUIZ$)
INVALIDCHAR%=0
FOR I%=1 TO LEN(QUIZ$)
	IF MATCH(MID$(QUIZ$,I%,1),VALIDCHAR$,1)=0 THEN INVALIDCHAR%=-1
NEXT I%
IF INVALIDCHAR% THEN PRINT FN.PROMPT$(13,1);"INVALID CHARACTER":GOTO 220
FILENAME$=DRIVE$+QUIZ$+".QZ"
PRINT FN.PROMPT$(14,1);"READY TO FIND AND READ ";FILENAME$
PRINT FN.CURSOR$(15,1);"PRESS <RETURN> WHEN READY OR 'N' TO CHANGE MIND";
IF UCASE$(CHR$(CONCHAR%))="N" THEN 200
IF SIZE(FILENAME$)=0 THEN PRINT CLR$;"     NO SUCH FILE, TRY AGAIN":GOTO 205
REM *****FILE CHECKS OUT OK*******
OPEN FILENAME$ RECL 22 AS 1
READ #1,1;QUIZLEN$
IF QUIZLEN$="BLANK" OR QUIZLEN$="" THEN 1000
QUIZLEN%=INT%(VAL(QUIZLEN$))
PRINT
PRINT "THE LAST QUESTION WAS #";QUIZLEN%
PRINT "***WAIT***"
STARTAT%=QUIZLEN%+2
FOR I%=1 TO 4000:NEXT I%
GOTO 500
REM *************************************
REM *	EDIT AN EXISTING FILE		*
REM *************************************
300	PRINT CLR$;"		EDIT A QUIZ"
305 INITIALIZE
310  PRINT FN.PROMPT$(9,1);"ON WHICH DRIVE IS THE QUIZ,"
PRINT FN.PROMPT$(10,1);"A OR B (OR X TO EXIT)?";
DRIVE$=UCASE$(CHR$(CONCHAR%))
IF MATCH(DRIVE$,"ABX",1)=0 THEN PRINT BEL$:GOTO 310
IF DRIVE$="X" THEN 50
DRIVE$=DRIVE$+":"
320  PRINT FN.PROMPT$(12,1);
INPUT "NAME OF QUIZ:"; LINE QUIZ$
IF LEN(QUIZ$)>8 THEN PRINT FN.PROMPT$(13,1);"TOO LONG":GOTO 320
QUIZ$=UCASE$(QUIZ$)
INVALIDCHAR%=0
FOR I%=1 TO LEN(QUIZ$)
	IF MATCH(MID$(QUIZ$,I%,1),VALIDCHAR$,1)=0 THEN INVALIDCHAR%=-1
NEXT I%
IF INVALIDCHAR% THEN PRINT FN.PROMPT$(13,1);"INVALID CHARACTER":GOTO 320
FILENAME$=DRIVE$+QUIZ$+".QZ"
FILEBAK$=DRIVE$+QUIZ$+".BAK"
PRINT FN.PROMPT$(14,1);"READY TO READ ";FILENAME$
PRINT FN.CURSOR$(15,1);"PRESS <RETURN> WHEN READY OR 'N' TO CHANGE MIND";
IF UCASE$(CHR$(CONCHAR%))="N" THEN 300
IF SIZE(FILENAME$)=0 THEN PRINT CLR$;"     NO SUCH FILE, TRY AGAIN":GOTO 305
REM *****FILE NAME CHECKS OUT OK*******
IF END #2 THEN 398
PRINT CLR$;"    MAKING BACKUP FILE FOR ";FILENAME$
OPEN FILENAME$ RECL 22 AS 1
CREATE FILEBAK$ RECL 22 AS 2
READ #1,1;QUIZLEN$
IF QUIZLEN$="BLANK" OR QUIZLEN$="" THEN 398
QUIZLEN%=INT%(VAL(QUIZLEN$))
PRINT #2,1;QUIZLEN$
FOR I%=2 TO QUIZLEN%+1
	READ #1,I%;QUESTION$,ANSWER$
	PRINT #2,I%;QUESTION$,ANSWER$
NEXT I%
REM ******READY TO EDIT*******
330	PRINT CLR$;TAB(15);"WORKING ON ";FILENAME$
PRINT #1,1;"BLANK",""
DELETED%=0
REM *DISPLAY*
PRINT FN.CURSOR$(8,21);DIM$;"MAX LENGTH>|";BRITE$
PRINT FN.CURSOR$(9,20);DIM$;"123456789012";BRITE$
PRINT FN.CURSOR$(10,10);"QUESTION:"
PRINT FN.CURSOR$(12,12);"ANSWER:"
340	PRINT FN.PROMPT$(14,1);"CONTINUE?(Y/N):";
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN PRINT BEL$:GOTO 340
IF YN$ NE "Y" THEN 370
341 PRINT FN.PROMPT$(14,1);
INPUT "QUESTION # TO EDIT"; LINE R$
IF LEN(R$)>3 THEN PRINT BEL$:GOTO 341
INVALIDCHAR%=0
FOR I%=1 TO LEN(R$)
	IF MATCH(MID$(R$,I%,1),"0123456789",1)=0 THEN INVALIDCHAR%=-1
NEXT I%
IF INVALIDCHAR% THEN PRINT BEL$:GOTO 341
R%=INT%(VAL(R$))
IF R%<1 OR R%>QUIZLEN% THEN PRINT BEL$;FN.PROMPT$(15,1);"NO SUCH #":GOTO 341
PRINT FN.PROMPT$(15,1)
READ #2,R%+1;QUESTION$,ANSWER$
PRINT FN.PROMPT$(10,19);QUESTION$
PRINT FN.PROMPT$(12,19);ANSWER$
350 PRINT FN.PROMPT$(14,1);"<D>ELETE OR <E>DIT?";
YN$=UCASE$(CHR$(CONCHAR%))
IF YN$="E" THEN 354
IF YN$ NE "D" THEN PRINT BEL$:GOTO 350
PRINT #1,R%+1;"???","?"
DELETED%=DELETED%+1
GOTO 340
354 PRINT FN.PROMPT$(14,1);"ENTER QUESTION #";R%
355  PRINT FN.CURSOR$(10,19);DELRIGHT$;FN.CURSOR$(10,18);
INPUT ":"; LINE QUESTION$
IF LEN(QUESTION$)>13 THEN \
  PRINT FN.PROMPT$(14,1);"TOO LONG": GOTO 355
IF MATCH(CHR$(34),QUESTION$,1)>0 THEN\
  PRINT FN.PROMPT$(14,1);"NO QUOTES ALLOWED": GOTO 355
REM **NOW ANSWER**
360	IF CONSTAT% THEN DUM%=CONCHAR%
PRINT FN.PROMPT$(14,1);"ENTER THE ANSWER TO #";R%
365 PRINT FN.CURSOR$(12,19);DELRIGHT$;FN.CURSOR$(12,20);
ANSWER%=CONCHAR%
IF (ANSWER%<32) OR (ANSWER%>126) THEN PRINT BEL$: GOTO 360
ANSWER$=CHR$(ANSWER%)
REM ******
PRINT FN.CURSOR$(10,20);QUESTION$;DELRIGHT$
PRINT FN.CURSOR$(12,20);ANSWER$;DELRIGHT$
366  PRINT FN.PROMPT$(14,1);"IS THIS CORRECT?(Y/N)";
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN PRINT BEL$:GOTO 366
IF YN$="N" THEN 354
REM *****
PRINT FN.PROMPT$(14,1);"WRITING NUMBER ";R%
PRINT #1,R%+1;QUESTION$,ANSWER$
REM *****
GOTO 340
REM *****
370 PRINT FN.PROMPT$(14,1);"ARE YOU FINISHED?(Y/N)";
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN PRINT BEL$:GOTO 370
IF YN$ NE "Y" THEN 340
PRINT CLR$;"    WRITING AND SAVING ";FILENAME$
R%=2
375 IF R%>(QUIZLEN%+1) THEN 390
READ #1,R%;QUESTION$,ANSWER$
IF QUESTION$ NE "???" THEN 385
I%=1
376 IF R%+I%>QUIZLEN%+1 THEN 390
READ #1,R%+I%;QUESTION$,ANSWER$
IF QUESTION$ NE "???" THEN 380
I%=I%+1
GOTO 376
380 PRINT #1,R%;QUESTION$,ANSWER$
    PRINT #1,R%+I%;"???","?"
385 R%=R%+1:GOTO 375
390 I%=0:R%=0
NEWQUIZLEN%=QUIZLEN%-DELETED%
NEWQUIZLEN$=STR$(FLOAT(NEWQUIZLEN%))
PRINT #1,1;NEWQUIZLEN$
GOTO 399
REM *****ERROR MESSAGE***
398 PRINT "FILE ERROR"
REM *****CLOSE FILES******
399 PRINT "CLOSING FILES"
CLOSE 1,2
GOTO 50
REM *************************************
REM *	PRINT A QUIZ FILE               *
REM *************************************
400	PRINT CLR$;"		PRINT A QUIZ"
405 INITIALIZE
410  PRINT FN.PROMPT$(9,1);"ON WHICH DRIVE IS THE QUIZ,"
PRINT FN.PROMPT$(10,1);"A OR B (OR X TO EXIT)?";
DRIVE$=UCASE$(CHR$(CONCHAR%))
IF MATCH(DRIVE$,"ABX",1)=0 THEN PRINT BEL$:GOTO 410
IF DRIVE$="X" THEN 50
DRIVE$=DRIVE$+":"
420  PRINT FN.PROMPT$(12,1);
INPUT "NAME OF QUIZ:"; LINE QUIZ$
IF LEN(QUIZ$)>8 THEN PRINT FN.PROMPT$(13,1);"TOO LONG":GOTO 420
QUIZ$=UCASE$(QUIZ$)
INVALIDCHAR%=0
FOR I%=1 TO LEN(QUIZ$)
	IF MATCH(MID$(QUIZ$,I%,1),VALIDCHAR$,1)=0 THEN INVALIDCHAR%=-1
NEXT I%
IF INVALIDCHAR% THEN PRINT FN.PROMPT$(13,1);"INVALID CHARACTER":GOTO 420
FILENAME$=DRIVE$+QUIZ$+".QZ"
PRINT FN.PROMPT$(14,1);"READY TO READ ";FILENAME$
PRINT FN.CURSOR$(15,1);"PRESS <RETURN> WHEN READY OR 'N' TO CHANGE MIND";
IF UCASE$(CHR$(CONCHAR%))="N" THEN 400
IF SIZE(FILENAME$)=0 THEN PRINT CLR$;"     NO SUCH FILE, TRY AGAIN":GOTO 405
REM ********FILE CHECKS OUT OK**********
430  OPEN FILENAME$ RECL 22 AS 1
READ #1,1;QUIZLEN$
IF QUIZLEN$="BLANK" OR QUIZLEN$="" THEN GOTO 1000
QUIZLEN%=INT%(VAL(QUIZLEN$))
PRINT CLR$;"           READY TO PRINT"
PRINT:PRINT "MAKE SURE PRINTER IS READY"
PRINT "PRESS <RETURN> TO BEGIN PRINTING"
WHILE NOT CONSTAT%:WEND:DUM%=CONCHAR%
PRINT CLR$;"      PRINTING ";FILENAME$
LPRINTER
PRINT TAB(20);FILENAME$:PRINT
PRINT "NUMBER","QUESTION","ANSWER":PRINT
FOR I%=1 TO QUIZLEN%
	READ #1,I%+1;QUESTION$,ANSWER$
	PRINT I%, QUESTION$, ANSWER$
NEXT I%
CONSOLE
PRINT BEL$
GOTO 1100
REM *************************************
REM *	EXIT TO GHOST MENU		*
REM *************************************
490 PRINT:PRINT "CHAINING BACK TO GHOST"
CHAIN "GHOST"
REM *************************************
REM *	OPEN AND WRITE TO A FILE	*
REM *************************************
500	PRINT CLR$;TAB(15);"WORKING ON ";FILENAME$
PRINT #1,1;"BLANK",""
R%=STARTAT%
REM *DISPLAY*
PRINT FN.CURSOR$(8,21);DIM$;"MAX LENGTH>|";BRITE$
PRINT FN.CURSOR$(9,20);DIM$;"123456789012";BRITE$
PRINT FN.CURSOR$(10,10);"QUESTION:"
PRINT FN.CURSOR$(12,12);"ANSWER:"
550	PRINT FN.PROMPT$(14,1);"CONTINUE?(Y/N):";
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN PRINT BEL$:GOTO 550
IF YN$ NE "Y" THEN 600
560  PRINT FN.PROMPT$(10,19):PRINT FN.PROMPT$(12,19)
PRINT FN.PROMPT$(14,1);"ENTER QUESTION #";R%-1
565  PRINT FN.CURSOR$(10,19);DELRIGHT$;FN.CURSOR$(10,18);
INPUT ":"; LINE QUESTION$
IF LEN(QUESTION$)>13 THEN \
  PRINT FN.PROMPT$(14,1);"TOO LONG": GOTO 565
IF MATCH(CHR$(34),QUESTION$,1)>0 THEN\
  PRINT FN.PROMPT$(14,1);"NO QUOTES ALLOWED": GOTO 565
REM **NOW ANSWER**
570	IF CONSTAT% THEN DUM%=CONCHAR%
PRINT FN.PROMPT$(14,1);"ENTER THE ANSWER TO #";R%-1
575 PRINT FN.CURSOR$(12,19);DELRIGHT$;FN.CURSOR$(12,20);
ANSWER%=CONCHAR%
IF (ANSWER%<32) OR (ANSWER%>126) THEN PRINT BEL$: GOTO 570
ANSWER$=CHR$(ANSWER%)
REM ******
PRINT FN.CURSOR$(10,20);QUESTION$;DELRIGHT$
PRINT FN.CURSOR$(12,20);ANSWER$;DELRIGHT$
580 PRINT FN.PROMPT$(14,1);"IS THIS CORRECT?(Y/N)";
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN PRINT BEL$:GOTO 580
IF YN$="N" THEN 560
REM *****
PRINT FN.PROMPT$(14,1);"WRITING NUMBER ";R%-1
PRINT #1,R%;QUESTION$,ANSWER$
REM *****
R%=R%+1
GOTO 550
REM *****
600 PRINT FN.PROMPT$(14,1);"ARE YOU FINISHED?(Y/N)";
YN$=UCASE$(CHR$(CONCHAR%))
IF MATCH(YN$,"YN",1)=0 THEN PRINT BEL$:GOTO 600
IF YN$="N" THEN 550
REM *****
PRINT FN.CURSOR$(14,1);"CLOSING ";FILENAME$;" WITH ";R%-1;" QUESTIONS."
PRINT #1,1;STR$(FLOAT(R%-2))
GOTO 1100
REM *************************
REM * FILE ERROR ROUTINE    *
REM *************************
1000 PRINT CLR$
PRINT FN.CURSOR$(10,1);"FILE ERROR IN ";FILENAME$
REM *************************
REM * CLOSE THE FILE        *
REM *************************
1100	PRINT CLR$;"       CLOSING ";FILENAME$
CLOSE 1
GOTO 50
END
