REM *************************************
REM *		GHOST			*
REM *	ENTRANCE POINT FOR GHOST GAME	*
REM *    CHOOSES WHICH QUIZ TO USE      *
REM *      AND PLAYS GHOST GAME         *
REM *	                                *
REM *	by J.D. Sackman	     1982	*
REM *************************************
REM Modified 12-JAN-83 by Kelly Smith, Wizard of OsZ
REM Copyright (C) 1983 by Jeffry D. Sackman
%CHAIN 50,14000,1000,1000
REM *********GRAPHIC VARIABLES & FUNCTIONS********
BEL$=CHR$(7)
BACKSP$=CHR$(8)
DOWN$=CHR$(10)
UP$=CHR$(11)
FRWRDSP$=CHR$(12)
BLINE$=CHR$(13)
CLR$=CHR$(26)
HOME$=CHR$(30)
ESC$=CHR$(27)
DIM$=ESC$+CHR$(41)
BRITE$=ESC$+CHR$(40)
INSLINE$=ESC$+CHR$(69)
GR$=ESC$+CHR$(103)
GROFF$=ESC$+CHR$(71)
UL$=ESC$+CHR$(108)
ULOFF$=ESC$+CHR$(109)
INS$=ESC$+CHR$(81)
DELINE$=ESC$+CHR$(82)
DELRIGHT$=ESC$+CHR$(84)
DEL$=ESC$+CHR$(87)
REM FUNCTION TO POSITION CURSOR AT GIVEN
REM LINE AND COLUMN
DEF FN.CURSOR$(LINE%,COLUMN%)=ESC$+"="+CHR$(LINE%+32)+CHR$(COLUMN%+32)
REM FUNCTION TO POSITION SCREEN AT GIVEN
REM LINE AND COLUMN
DEF FN.SCREEN$(LINE%,COLUMN%)=ESC$+"S"+CHR$(LINE%+32)+CHR$(COLUMN%+32)
DIM QUESTION$(50)
DIM ANSWER$(50)
REM **FUNCTION TO CLEAR LINE AND READY FOR PROMPT**
DEF FN.PROMPT$(L%,C%)=FN.CURSOR$(L%,C%)+DELRIGHT$+FN.CURSOR$(L%,C%)
VALIDCHAR$="ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-"
REM ************************************
PRINT CLR$:PRINT:PRINT "                Ghost in the Chimney"
PRINT "      Copyright (C) 1983 by Jeffry D. Sackman"
FOR I=1 TO 1000:NEXT I
50 	PRINT CLR$
	PRINT FN.CURSOR$(3,17);"** GHOST IN THE CHIMNEY **"
	PRINT FN.CURSOR$(6,20);"GHOST MENU"
	PRINT
	PRINT "You have a choice of ghostly quizes."
	PRINT "Type a number 1 to 5 for your choice."
	PRINT
	PRINT TAB(5);"1 - Identifying small letters"
	PRINT TAB(5);"2 - Simple Addition and Subtraction"
	PRINT TAB(5);"3 - Write file of questions and answers"
	PRINT TAB(5);"4 - Read a file of questions & answers"
	PRINT TAB(5);"5 - Exit to the main menu"
	PRINT
100	PRINT FN.CURSOR$(17,1);"YOUR CHOICE IS NUMBER:";
110	A$=CHR$(CONCHAR%)
	IF MATCH(A$,"12345",1)>0 THEN 115
	PRINT FN.CURSOR$(17,1);DELRIGHT$
	PRINT FN.CURSOR$(17,1);"INPUT A NUMBER FROM 1 TO 5:";:GOTO 110
115	PRINT FN.CURSOR$(18,1);"YOU CHOSE NUMBER ";A$;", CORRECT (Y/N)?";
	YN$=CHR$(CONCHAR%)
	IF UCASE$(YN$)="Y" THEN 120
	PRINT FN.CURSOR$(18,1);DELRIGHT$
	PRINT FN.CURSOR$(17,1);DELRIGHT$: GOTO 100
120	A%=INT%(VAL(A$))
	ON A% GOTO 1000,2000,3000,4000,5000
1000	REM *********************************************
	REM *	SMALL LETTER QUIZ FOR 'GHOST' GAME      *
	REM *********************************************
	PRINT CHR$(26):PRINT:PRINT:PRINT:PRINT:PRINT
	PRINT TAB(17);"**GHOST IN THE CHIMNEY**"
	PRINT:PRINT
	PRINT "     SMALL LETTER QUIZ"
	PRINT
	PRINT "  CHILD MUST INPUT THE CAPITAL LETTER"
	PRINT "  WHICH MATCHES THE SMALL LETTER UNDER"
	PRINT "  THE LIGHTNING BOLT."
	PRINT
	REM CLEAR CONSOLE OF LEFTOVER INPUT
	IF CONSTAT% THEN DUM%=CONCHAR%
	PRINT "PRESS <RETURN> TO BEGIN GAME"
	INPUT "OR 'N <RETURN>' TO GO BACK TO MENU"; LINE DUMMY$
	RANDOMIZE
	IF DUMMY$="N" THEN 50
	REM CLEAR CONSOLE OF LEFTOVER INPUT
	IF CONSTAT% THEN DUM%=CONCHAR%
	PRINT "****** WAIT *******"
	REM *SET QUESTION SET*
	FOR I%=1 TO 50
		QUESTION$(I%)=CHR$(INT((RND*26)+97))
		ANSWER$(I%)=UCASE$(QUESTION$(I%))
	NEXT I%
	GOTO 10000
REM ***********************************************
REM * 	SIMPLE MATH QUIZ GENERATOR		  *
REM ***********************************************
2000	PRINT CLR$
PRINT FN.CURSOR$(9,1);"                     *GHOST IN THE CHIMNEY*"
PRINT FN.CURSOR$(11,1);"                       *SIMPLE MATH QUIZ*"
PRINT
PRINT "THESE QUESTIONS ARE ADDITION OR SUBTRACTION OF"
PRINT "TWO SINGLE DIGIT NUMBERS (1-9) WHERE THE ANSWER"
PRINT "IS ALSO A SINGLE DIGIT NUMBER (0-9).  E.G. 3 + 5."
PRINT "CHILD MUST RESPOND WITH A SINGLE DIGIT (0-9)."
PRINT
PRINT "PRESS <RETURN> TO BEGIN GAME"
INPUT "OR 'N <RETURN>' TO GO BACK TO MENU"; LINE DUMMY$
RANDOMIZE
IF DUMMY$="N" THEN 50
	REM CLEAR CONSOLE OF LEFTOVER INPUT
	IF CONSTAT% THEN DUM%=CONCHAR%
PRINT "*******WAIT*******"
REM ***GENERATE PROBLEMS*******
FOR I%=1 TO 50
	IF RND>0.5 THEN 2200
2100	REM *ADDITION*
		Q1=INT(RND*9)+1
		Q2=INT(RND*9)+1
		IF Q1+Q2>9 THEN 2100
		Q1$=STR$(Q1):Q2$=STR$(Q2)
		QUESTION$(I%)=Q1$+" + "+Q2$
		ANSWER$(I%)=STR$(Q1+Q2)
	GOTO 2300
2200	REM *SUBTRACTION*
		Q1=INT(RND*9)+1
		Q2=INT(RND*9)+1
		IF Q1-Q2<0 THEN 2200
		Q1$=STR$(Q1):Q2$=STR$(Q2)
		QUESTION$(I%)=Q1$+" - "+Q2$
		ANSWER$(I%)=STR$(Q1-Q2)
2300	NEXT I%
GOTO 10000
REM
REM ***********************************************
REM *  WRITE A QUIZ FILE (CHAINS TO WRITEQZ)	  *
REM *  CHAINS BACK TO GHOST WHEN FINISHED         *
REM ***********************************************
3000	PRINT CLR$
PRINT FN.CURSOR$(8,15);"*GHOST IN THE CHIMNEY*"
PRINT FN.CURSOR$(10,17);"WRITE A QUIZ FILE"
PRINT
PRINT "THIS OPTION ALLOWS YOU TO WRITE YOUR OWN SET OF"
PRINT "QUESTIONS AND ANSWERS TO USE IN THE GHOST GAME."
PRINT "THE QUIZ IS STORED AS A FILE ON THIS DISK OR"
PRINT "ANOTHER IN DRIVE B.  TO USE YOUR QUIZ, USE THE"
PRINT "-READ A FILE- OPTION (#4)."
PRINT "PRESS <RETURN> TO BEGIN WRITING A QUIZ"
PRINT "OR PRESS 'N' TO RETURN TO THE GHOST MENU";
IF UCASE$(CHR$(CONCHAR%))="N" THEN 50
PRINT:PRINT "*****CHAINING TO WRITE-A-QUIZ PROGRAM*****"
CHAIN "WRITEQZ"
REM ***********************************************
REM *	READ A QUIZ FILE			  *
REM ***********************************************
4000	PRINT CLR$
PRINT FN.CURSOR$(8,15);"*GHOST IN THE CHIMNEY*"
PRINT FN.CURSOR$(10,17);"READ A QUIZ FILE"
PRINT
PRINT "THIS OPTION ALLOWS YOU TO USE A QUIZ YOU HAVE"
PRINT "WRITTEN WITH THE -WRITE A QUIZ- OPTION IN THE "
PRINT "GHOST GAME.  YOUR QUIZ FILE MUST BE STORED ON"
PRINT "THIS DISK OR ANOTHER DISK IN DRIVE B."
PRINT
PRINT "PRESS <RETURN> TO CHOOSE YOUR QUIZ FILE"
INPUT "OR PRESS 'N <RETURN>' TO RETURN TO THE GHOST MENU"; LINE DUM$
RANDOMIZE
IF UCASE$(DUM$)="N" THEN 50
REM *************************
PRINT CLR$;"		READ A QUIZ"
4100  PRINT FN.PROMPT$(9,1);"ON WHICH DRIVE IS THE QUIZ,"
PRINT FN.PROMPT$(10,1);"A OR B (OR X TO EXIT)?";
DRIVE$=UCASE$(CHR$(CONCHAR%))
IF MATCH(DRIVE$,"ABX",1)=0 THEN PRINT BEL$:GOTO 4100
IF DRIVE$="X" THEN 50
DRIVE$=DRIVE$+":"
4200  PRINT FN.PROMPT$(12,1);
INPUT "NAME OF QUIZ:"; LINE QUIZ$
IF LEN(QUIZ$)>8 THEN PRINT FN.PROMPT$(13,1);"TOO LONG":GOTO 4200
QUIZ$=UCASE$(QUIZ$)
INVALIDCHAR%=0
FOR I%=1 TO LEN(QUIZ$)
	IF MATCH(MID$(QUIZ$,I%,1),VALIDCHAR$,1)=0 THEN INVALIDCHAR%=-1
NEXT I%
IF INVALIDCHAR% THEN PRINT FN.PROMPT$(13,1);"INVALID CHARACTER":GOTO 4200
FILENAME$=DRIVE$+QUIZ$+".QZ"
PRINT FN.PROMPT$(14,1);"READY TO READ ";FILENAME$
PRINT FN.CURSOR$(15,1);"PRESS <RETURN> WHEN READY OR 'N' TO CHANGE MIND";
IF UCASE$(CHR$(CONCHAR%))="N" THEN 4000
IF SIZE(FILENAME$)=0 THEN PRINT CLR$;"     NO SUCH FILE, TRY AGAIN":GOTO 4100
REM *****FILE CHECKS OUT OK********
PRINT CLR$;"        READING ";FILENAME$
IF END #1 THEN 4800
4300	OPEN FILENAME$ RECL 22 AS 1
READ #1,1;QUESTION$(0)
IF QUESTION$(0)="BLANK" OR QUESTION$(0)="" THEN 4800
QUIZLEN%=INT%(VAL(QUESTION$(0)))
PRINT:PRINT "        ARRANGING QUESTIONS AND ANSWERS"
FOR I%=1 TO 50
	READ #1,(INT%(RND*QUIZLEN%)+2);QUESTION$(I%),ANSWER$(I%)
NEXT I%
GOTO 4900
REM *****ERROR ROUTINE*******
4800  PRINT "FILE ERROR IN ";FILENAME$
CLOSE 1
GOTO 4000
REM *******CLOSE FILE********
4900 PRINT "CLOSING ";FILENAME$
CLOSE 1
GOTO 10000
REM **************************************
REM *  EXIT BACK TO THE MAIN MENU        *
REM **************************************
5000	STOP
10000   REM **********************************************
	REM 		GHOST IN THE CHIMNEY
	REM 		by J.D. Sackman  1982
	REM **********************************************
REM
REM *****GHOST PROGRAM VARIABLES*****
REM
DIM REPLIES$(50)
DIM WRONG$(50)
U$=CHR$(21):V$=CHR$(22):W$=CHR$(23):Y$=CHR$(25)
J$=CHR$(10):H$=CHR$(8):L$=CHR$(12)
DIM GHOST$(5)
GHOST$(1)=GR$+J$+V$+V$+V$+V$+H$+GROFF$
GHOST$(2)=GR$+V$+CHR$(0)+V$+V$+CHR$(0)+V$+GROFF$
GHOST$(3)=GR$+V$+V$+V$+V$+V$+V$+GROFF$
GHOST$(4)=GHOST$(3)
GHOST$(5)=GR$+U$+Y$+U$+Y$+U$+Y$+GROFF$
DIM ROOFL$(5)
DIM ROOFR$(5)
ROOFL$(1)="    "+J$
ROOFL$(2)="   "+J$+V$
ROOFL$(3)="  "+J$+V$+V$
ROOFL$(4)=" "+J$+V$+V$+V$
ROOFL$(5)=J$+V$+V$+V$+V$
ROOFR$(1)=H$+"    "
ROOFR$(2)=V$+H$+"   "
ROOFR$(3)=V$+V$+H$+"  "
ROOFR$(4)=V$+V$+V$+H$+" "
ROOFR$(5)=V$+V$+V$+V$+H$
ROOF$=V$
FOR I%=1 TO 19:ROOF$=ROOF$+V$:NEXT I%
WINDOW$=GR$+V$+V$+L$+L$+V$+V$+GROFF$
DIM BOLT$(22)
FOR I%=1 TO 21 STEP 2
	BOLT$(I%)=GR$+U$+H$+GROFF$
NEXT I%
FOR I%=2 TO 22 STEP 2
	BOLT$(I%)=GR$+J$+Y$+GROFF$
NEXT I%
DEF FN.LIGHTNING$(COLUMN%,GROUND%)
	FOR LI%=1 TO GROUND%
		PRINT FN.CURSOR$(LI%,COLUMN%);
		PRINT BOLT$(LI%)
	NEXT LI%
	PRINT BEL$
	FOR LI%=1 TO GROUND%
		PRINT FN.CURSOR$(LI%,COLUMN%);
		PRINT "  "
	NEXT LI%
	RETURN
FEND
REM *****************************************
REM ***BEGIN GAME WITH A FLASH***
10100 PRINT CLR$
PRINT FN.LIGHTNING$(26,21)
ALT%=0
WRONG%=0
FOR II%=1 TO 50
	WRONG$(II%)=""
NEXT II%
REM *****************************************
REM
REM *******SET UP GRAPHIC DISPLAY************
REM  ***PRINT CHIMNEY***
PRINT CLR$
FOR I%=8 TO 22
	PRINT FN.CURSOR$(I%,9);
	PRINT GR$+V$+V$+"        "+V$+V$+GROFF$
	REM              12345678
NEXT I%
REM
REM ***PRINT STEEPLE***
FOR I%=1 TO 5
	PRINT FN.CURSOR$(I%+7,24);
	PRINT GR$+ROOFL$(I%)+ROOFR$(I%)+GROFF$
NEXT I%
REM
REM ***PRINT WINDOW OF STEEPLE***
PRINT FN.CURSOR$(13,26);GHOST$(3)
PRINT FN.CURSOR$(14,26);WINDOW$
PRINT FN.CURSOR$(15,26);WINDOW$
PRINT FN.CURSOR$(16,26);GHOST$(3)
REM
REM ***PRINT LEFT SIDE OF ROOF***
FOR I% = 1 TO 5
	PRINT FN.CURSOR$(I%+16,1);GR$+ROOFL$(I%)+V$+V$+V$+GROFF$
NEXT I%
REM
REM ***PRINT RIGHT SIDE OF ROOF***
FOR I%=1 TO 5
	PRINT FN.CURSOR$(I%+16,21);GR$+ROOF$+ROOFR$(I%)+GROFF$
NEXT I%
REM
REM ***PRINT GHOST IN MIDDLE OF CHIMNEY*****
FOR I%=1 TO 5
	PRINT FN.CURSOR$((ALT%+13+I%),12);
	PRINT GHOST$(I%)
NEXT I%
REM *****************************************
REM ***ACTUAL PLAY OF GAME***
11000 	PRINT FN.LIGHTNING$(28,7)
	PRINT FN.LIGHTNING$(14,ALT%+13)
	PRINT FN.CURSOR$(12,39);GR$+CHR$(13)+GROFF$
11010 REM *BEGIN CYCLE*
	FOR J%=1 TO 50
11020  PRINT FN.LIGHTNING$(39,10)
PRINT FN.CURSOR$(13,39);
	REM CLEAR CONSOLE OF LEFTOVER INPUT
	IF CONSTAT% THEN DUM%=CONCHAR%
PRINT FN.PROMPT$(11,39);
PRINT QUESTION$(J%)
PRINT FN.CURSOR$(13,39);DELRIGHT$;FN.CURSOR$(13,39);
REM WAIT FOR RESPONSE
WHILE NOT CONSTAT%
WEND
REPLY$=UCASE$(CHR$(CONCHAR%))
IF ASC(REPLY$)<32 OR ASC(REPLY$)>126 THEN REPLY$=""
	REM CLEAR CONSOLE OF LEFTOVER INPUT
	IF CONSTAT% THEN DUM%=CONCHAR%
PRINT FN.CURSOR$(13,39);REPLY$;DELRIGHT$
	IF CONSTAT% THEN DUM%=CONCHAR%
REM NOW REINFORCEMENT
IF REPLY$=ANSWER$(J%) THEN GOSUB 12000 ELSE GOSUB 12050
REPLIES$(J%)=REPLY$
IF REPLY$=ANSWER$(J%) THEN GOTO 11030
PRINT FN.CURSOR$(13,42); DIM$+"-NO-  "+BRITE$+ANSWER$(J%)
FOR I%=1 TO 2000
NEXT I%
IF J%>49 THEN 11025
REM REPEAT THE MISSED QUESTION FOR REVIEW
QUESTION$(J%+1)=QUESTION$(J%)
ANSWER$(J%+1)=ANSWER$(J%)
11025 REM MARK ANSWER AS WRONG
WRONG$(J%)="*"
WRONG%=WRONG%+1
REM CHECK IF GHOST ON TOP OR BOTTOM OF CHIMNEY
11030 IF ALT%>3 THEN GOTO 12100
IF ALT%<-7 THEN GOTO 12200
11100 NEXT J%
REM IF LOOP RAN TO 50 WITHOUT AN EXIT, J% IS NOW 51
REM RESET J%
J%=50
GOTO 13000
REM **************************************
REM *****SUBROUTINES**********************
REM *****MOVE GHOST UP************
REM
12000 PRINT FN.CURSOR$((ALT%+18),12);
PRINT "      ";
FOR I%=5 TO 1 STEP -1
	PRINT FN.CURSOR$((ALT%+I%+12),12);GHOST$(I%)
NEXT I%
ALT%=ALT%-1
RETURN
REM
REM ******************************
REM *****MOVE GHOST DOWN**********
REM
12050 PRINT FN.CURSOR$((ALT%+14),12);"      ";
FOR I%=1 TO 5
	PRINT FN.CURSOR$((ALT%+I%+14),12);GHOST$(I%)
NEXT I%
ALT%=ALT%+1
RETURN
REM
REM ******************************
REM GHOST FELL IN THE HOUSE**
12100	FOR K%=1 TO 5
PRINT FN.CURSOR$(K%+17,12);DIM$+GHOST$(K%)+BRITE$
	NEXT K%
	GOTO 13000
REM *****************************
REM GHOST ESCAPES**
12200	PRINT FN.LIGHTNING$(14,ALT%+13)
	FOR K%=1 TO 6
		GOSUB 12000
	NEXT K%
	FOR I%=1 TO 20
		PRINT FN.CURSOR$(7,1);INSLINE$;BEL$
		FOR JJ%=1 TO 30:NEXT JJ%
	NEXT I%
	GOTO 13000
REM ****************************
REM ***END OF GAME***
13000 PRINT FN.CURSOR$(18,20);"END OF GAME"
IF WRONG%=0 THEN PRINT FN.CURSOR$(16,20);"!!!!!!HOORAY!!!!!!"
PRINT FN.CURSOR$(19,20);J%;" QUESTIONS   ";WRONG%;" WRONG"
	REM CLEAR CONSOLE OF LEFTOVER INPUT
	IF CONSTAT% THEN DUM%=CONCHAR%
PRINT FN.CURSOR$(20,20);"PRESS:'P' to print responses"
PRINT FN.CURSOR$(21,26);"'RETURN' to play again"
PRINT FN.CURSOR$(22,26);"'Q' to quit"
WHILE NOT CONSTAT%
WEND
X$=CHR$(CONCHAR%)
	REM CLEAR CONSOLE OF LEFTOVER INPUT
	IF CONSTAT% THEN DUM%=CONCHAR%
IF UCASE$(X$)="P" THEN GOTO 13500
IF UCASE$(X$)="Q" THEN GOTO 50
PRINT FN.LIGHTNING$(39,21)
REM *** 'SHUFFLE' ORDER OF QUESTIONS ***
SHUFFLE%=INT%(RND*5)*2+3
FOR I%= 1 TO (50-SHUFFLE%) STEP 2
	SWAPQ$=QUESTION$(I%+SHUFFLE%)
	SWAPA$=ANSWER$(I%+SHUFFLE%)
	QUESTION$(I%+SHUFFLE%)=QUESTION$(I%)
	ANSWER$(I%+SHUFFLE%)=ANSWER$(I%)
	QUESTION$(I%)=SWAPQ$
	ANSWER$(I%)=SWAPA$
NEXT I%
FOR I%= 1 TO 25
	SWAPQ$=QUESTION$(51-I%)
	SWAPA$=ANSWER$(51-I%)
	QUESTION$(51-I%)=QUESTION$(I%)
	ANSWER$(51-I%)=ANSWER$(I%)
	QUESTION$(I%)=SWAPQ$
	ANSWER$(I%)=SWAPA$
NEXT I%
SHUFFLE%=INT%(RND*5)*2+3
FOR I%= 1 TO (50-SHUFFLE%) STEP 2
	SWAPQ$=QUESTION$(I%+SHUFFLE%)
	SWAPA$=ANSWER$(I%+SHUFFLE%)
	QUESTION$(I%+SHUFFLE%)=QUESTION$(I%)
	ANSWER$(I%+SHUFFLE%)=ANSWER$(I%)
	QUESTION$(I%)=SWAPQ$
	ANSWER$(I%)=SWAPA$
NEXT I%
GOTO 10100
STOP
REM ****************************
REM **PRINT RESPONSES**
13500 PRINT CLR$
	REM CLEAR CONSOLE OF LEFTOVER INPUT
	IF CONSTAT% THEN DUM%=CONCHAR%
PRINT FN.CURSOR$(10,10);"MAKE SURE PRINTER IS READY"
PRINT FN.CURSOR$(12,10);"PRESS 'N' IF YOU CHANGED YOUR MIND"
PRINT FN.CURSOR$(14,10);"PRESS ANY OTHER KEY TO BEGIN PRINT"
WHILE NOT CONSTAT%
WEND
DUMP%=CONCHAR%
IF UCASE$(CHR$(DUMP%))="N" THEN 13000
LPRINTER
PRINT "PROMPT", "ACTUAL", "CORRECT"
PRINT "QUESTION", "RESPONSE", "ANSWER": PRINT
FOR I%=1 TO J%
	PRINT QUESTION$(I%);WRONG$(I%), REPLIES$(I%), ANSWER$(I%)
NEXT I%
PRINT
PRINT J%;" QUESTIONS",WRONG%;" WRONG", 100*(J%-WRONG%)/J%;"% SCORE"
PRINT "* INDICATES INCORRECT ANSWER"
CONSOLE
PRINT CLR$
GOTO 13000
14000 GOTO 50
END
